#!/bin/env python

# usage: simi.py (similar|exact) inputfile 
# input file format:
# smiles identifier
#
# Contributing authors:
#   Teague Sterling, Pascal Wassam, Gurgen Turmanian and John Irwin, 2010-2013
#

import xmlrpclib, sys, pprint

mode = sys.argv[1]
if(mode != 'similar' and mode != 'exact'):
	print "Invalid mode '%s'" % mode;
	sys.exit(1)

lines = file(sys.argv[2]).readlines()
lookups = {}

for l in lines:
	t = l.split()
	smi = t[0]
	id = ' '.join(t[1:])
	if len(id) == 0: id = None
	lookups[smi] = id

#server_url = "http://advisorcmd.docking.org/aggregate_lookup/xml-rpc/"
server_url = "http://localhost:8080/aggregate_lookup/xml-rpc/"
server = xmlrpclib.ServerProxy(server_url);

for (smi, id) in lookups.iteritems():
	if mode == 'similar':
		result = server.similarity.getSimilars(smi)
		try:
			for r in result['aggregators']:
				print "%s\t%s\t%.2f\t%s" % (smi, r['smile'], r['similarity'], lookups[smi])
		except:
			pass

	if mode == 'exact':
		result = server.similarity.getExactMatch(smi)
		try:
			print "%s\t%s\t%.2f\t%s" % (smi, result['aggregators'][0]['smile'], result['aggregators'][0]['similarity'], lookups[smi])
		except:
			pass
		
